Subject: Re: [bitcoindev] [BIP Proposal] Mempool Validation and Relay Policies via User-Defined Scripts

From: Greg Maxwell <[email-masked]>
Date: Thu, 25 Sep 2025 20:03:09 +0000

> 1) Allowing node

Who said anything about allowing?  Everyone is allowed to do whatever they
want.  Drill a hole in your head if you like, not my concern.  None of this
thread is about what people are allowed to do-- that's off the table.  The
design and licensing of Bitcoin is such that no one gets to stop anyone
else from what they want to do anyways (which is, in fact, a big part of
the issue here).   To think otherwise is to be stuck in a kind of serf
thinking where you can only do what other people allow you to do.  That has
never been what Bitcoin was about.

Rather, the question is should people who care about Bitcoin spend their
time and money developing infrastructure that would be useful, even
primarily useful, for censorship.  I say no.  Especially because any time
spent on it is time away from anti-censorship pro-privacy tools and because
the effort spent doing so would undermine anti-censorship and pro-privacy
efforts because they would inevitably moot the efforts expected getting
into peoples business and filtering their transactions.

You don't have to agree, and you're free to do your own thing just as I'm
free to say that I think it's a bad direction.  From the very beginning
Bitcoin has stood against the freedom to transact being overridden by some
admin based on their judgment call weighing principles against other
concerns, or at the behest of their superiors.  So many Bitcoiner will
stand against, route around, and do what they can do to make ineffectual
the blocking of consensual transactions.  It might not seem as many at the
moment, but the pro-privacy and anti-censorship 'side' doesn't have a paid
PR and influence campaign,  but it also doesn't matter so much because
Bitcoin takes advantage of the nature of information being easy to spread
and hard to stifel and it doesn't that that huge an effort to route around
censorship efforts.

There are elements of anti-censorship in Bitcoin that have been so far
underdeveloped.  It's unfortunate that their further development might be
forced at a time when efforts are needed on other areas.  But perhaps they
wouldn't get done without a concrete motivation. Such is life.

On Thu, Sep 25, 2025 at 9:21 AM yes_please <[email-masked]>
wrote:

> Sorry Greg, could you please elaborate further on your ideas? Some are not
> exactly clear:
>
> 1) Allowing node runners to configure their node as they please and
> refuse to relay some txs is considered authoritarian, censorship, and an
> attempt to regulate third parties conduct. On the other hand, forcing nodes
> to merge towards a single shared configuration (by preventing them to block
> txs) is not considered authoritarian because this imposition does not
> discriminate towards any txs and is thus non-authoritarian? Did I get the
> reasoning correctly here?
>
> 2) If the aim is to have a homogenous mempool state and to model what
> will get mined, shouldn’t we reach this state through distributed
> independent nodes who decide independently on what they prefer this
> homogenous state to be? If we don’t reach this state through this
> distributed/independent mechanism, then how are we to reach this state? Who
> gets to decide and steer the direction so that we all converge towards this
> homogenous state?  One of the strongest aspects of bitcoin is the fact that
> no single party can force a change/direction, and the network has to
> somehow reach a shared agreement through independent decision makers who
> act in what manner they think is best. The proposed BIP seems to be aligned
> with such a principle, I fail to see any authoritarian aspect here.
>
> 3) I share your sentiment and the aim to have a homogenous mempool state,
> but I am skeptical of the manner in which we are to achieve this according
> to the ideas you have here expressed (namely not through a distributed
> independent organic manner)
>
>
> Respectfully, yes_please
>
> On Thu, Sep 25, 2025 at 12:50 AM Greg Maxwell <[email-masked]> wrote:
>
>> So that when the "consistent state" changes as a result of some issue you
>> can update configs instead of having to update software-- which has
>> considerable more costs and risks, especially if you're carrying local
>> customizations as many miners do.
>>
>>
>> On Wed, Sep 24, 2025 at 8:47 PM Aiden McClelland <[email-masked]> wrote:
>>
>>> If mempool consistency across the network is all that is important, why
>>> allow any configuration of mempool relay policies at all?
>>>
>>> On Wednesday, September 24, 2025 at 12:47:28 PM UTC-6 Greg Maxwell wrote:
>>>
>>>> This appears to substantially misunderstands the purpose of the mempool
>>>> broadly in the network-- it's purpose is to model what will get mined.  If
>>>> you're not doing that you might as well set blocks only.
>>>> Significant discrepancies are harmful to the system and promote
>>>> centralization and fail to achieve a useful purpose in any case.  What
>>>> marginal benefits might be provided do not justify building and deploying
>>>> the technological infrastructure for massive censorship.
>>>>
>>>> If you think this is important, I advise you to select another
>>>> cryptocurrency which is compatible with such authoritarian leanings.  --
>>>> though I am unsure if any exist since it is such a transparently pointless
>>>> direction.
>>>>
>>>>
>>>> On Wed, Sep 24, 2025 at 6:30 PM Aiden McClelland <[email-masked]>
>>>> wrote:
>>>>
>>>>> Hi all,
>>>>>
>>>>> I'd like to share for discussion a draft BIP to allow for a modular
>>>>> mempool/relay policy: https://github.com/bitcoin/bips/pull/1985
>>>>>
>>>>> I think it could potentially reduce conflict within the community
>>>>> around relay policy, as an alternative to running lots of different node
>>>>> implementations/forks when there are disagreements.
>>>>>
>>>>> I am working on a reference implementation using Bellard's QuickJS,
>>>>> but it has been almost a decade since I've written C++, so it's slow going
>>>>> and I'm sure doesn't follow best-practices. Once it's working, it can be
>>>>> cleaned up.
>>>>>
>>>>> Thanks,
>>>>> Aiden McClelland
>>>>>
>>>>> --
>>>>> You received this message because you are subscribed to the Google
>>>>> Groups "Bitcoin Development Mailing List" group.
>>>>> To unsubscribe from this group and stop receiving emails from it, send
>>>>> an email to [email-masked].
>>>>> To view this discussion visit
>>>>> https://groups.google.com/d/msgid/bitcoindev/cbdab6fa-93bc-44c9-80f0-6c68c6554f56n%40googlegroups.com
>>>>> <https://groups.google.com/d/msgid/bitcoindev/cbdab6fa-93bc-44c9-80f0-6c68c6554f56n%40googlegroups.com?utm_medium=email&utm_source=footer>
>>>>> .
>>>>>
>>>> --
>>> You received this message because you are subscribed to the Google
>>> Groups "Bitcoin Development Mailing List" group.
>>> To unsubscribe from this group and stop receiving emails from it, send
>>> an email to [email-masked].
>>> To view this discussion visit
>>> https://groups.google.com/d/msgid/bitcoindev/de4dae19-86f4-4d7a-a895-b48664babbfcn%40googlegroups.com
>>> <https://groups.google.com/d/msgid/bitcoindev/de4dae19-86f4-4d7a-a895-b48664babbfcn%40googlegroups.com?utm_medium=email&utm_source=footer>
>>> .
>>>
>> --
>> You received this message because you are subscribed to the Google Groups
>> "Bitcoin Development Mailing List" group.
>> To unsubscribe from this group and stop receiving emails from it, send an
>> email to [email-masked].
>> To view this discussion visit
>> https://groups.google.com/d/msgid/bitcoindev/CAAS2fgRABqRe1j6xzW0uhVrDiQnL6x1X6ALzfsJ7w4GztWVeNA%40mail.gmail.com
>> <https://groups.google.com/d/msgid/bitcoindev/CAAS2fgRABqRe1j6xzW0uhVrDiQnL6x1X6ALzfsJ7w4GztWVeNA%40mail.gmail.com?utm_medium=email&utm_source=footer>
>> .
>>
>

-- 
You received this message because you are subscribed to the Google Groups "Bitcoin Development Mailing List" group.
To unsubscribe from this group and stop receiving emails from it, send an email to [email-masked].
To view this discussion visit https://groups.google.com/d/msgid/bitcoindev/CAAS2fgSmiKhmQGAEo2eSQJmen-4kT1vD7dY8UESV4dQrjXau7w%40mail.gmail.com.